
# Exercice 0
n = bin(14)
print(n)

n = bin(218)
print(n)

n = bin(42)
print(n)

n = bin(57)
print(n)

# Exercice 1
n_2 = '10101011' # n_2 =  1 * 2**7 + 1 * 2**5 + 1 * 2**3 + 1 * 2**1 + 1 * 2**0
n_10 = int(n_2, 2)
print(n_10)
print( 1 * 2**7 + 1 * 2**5 + 1 * 2**3 + 1 * 2**1 + 1 * 2**0)

n_2 = '10000000'
n_10 = int(n_2, 2)
print(n_10)

n_2 = '11111111'
n_10 = int(n_2, 2)
print(n_10)

# Exercice 2
n_10 = 9
n_16 = hex(n_10)
print(n_16)

n_10 = 248
n_16 = hex(n_10)
print(n_16)

n_10 = 64
n_16 = hex(n_10)
print(n_16)


# Exercice 3
n_16 = 'BEEF' # n_16 = 11 * 16**3 + 14 * 16**2 + 14 * 16**1 + 15 * 16**0
n_10 = int(n_16, 16)
print(n_10)
print(11 * 16**3 + 14 * 16**2 + 14 * 16**1 + 15 * 16**0)

# Exercice 4 
n_2 = '1001010' 
n_10 = int(n_2, 2)
n_16 = hex(n_10)
print(n_16)

# Exercice 5
n_2 = bin(10)
print(n_2) # représentation binaire de |-10| =  -(-10) = 10 : 00001010
# Complément à un sur 8 bits : 11110100
# complément à deux sur 8 bits : 11110101

n_2 = bin(128)
print(n_2) # représentation binaire de |-128| : 10000000
# Complément à un sur 8 bits : 01111111
# complément à deux sur 8 bits : 10000000

n_2 = bin(48)
print(n_2) # représentation binaire de |-48| : 00110000
# Complément à un sur 8 bits : 11001111
# complément à deux sur 8 bits : 11010000

n_2 = bin(97)
print(n_2) # représentation binaire de |-97| : 01100001
# Complément à un sur 8 bits : 10011110
# complément à deux sur 8 bits : 10011111

# Exercice 6
# voir la synthèse de cours : Pour déterminer quel est l’entier négatif m représenté par une séquence de
# k bits donnée en complément à deux, il suﬃt de lui appliquer à nouveau une
# opération de complémentation à deux et de prendre l’opposé du résultat.
# 2**k - (2**k - |m|) = |m|

# Complément à un sur 8 bits de 11100111 : 00011000
# complément à deux sur 8 bits : 00011001
# On a 00011001 = 16 + 8 + 1 = 25
# Donc l'entier signé représenté par 11100111 en complément à deux est -25.

# Complément à un sur 8 bits de 11000001 : 00111110
# complément à deux sur 8 bits : 00111111
# On a 00111111 = 32 + 16 + 8 + 4 + 2 + 1 = 63
# Donc l'entier signé représenté par 11000001 en complément à deux est -63.


# Exercice 7
def nb_chiffre(n):
    q = n
    r = 0
    i = 0
    while q > 0 :
        r = q % 2
        q = q // 2
        i += 1
    return i

res = nb_chiffre(53)
print(res)

# Exercice 8

def complement(b):
    nb_bits = len(b)
    retenu = True    
    for j in range(nb_bits) :        
        i = nb_bits - 1 - j
        c = int(b[i],2)       
        if c == 0 :
            if not retenu :                
                print('1', end="")                                
            else :
                print('0', end="")
                retenu = True
        else :
            if not retenu :
                print('0', end="")
                retenu = False
            else :
                print('1', end="")
                retenu = False            
    print()
    
print("complément")
complement('11100111')